/* $Id: debug.h,v 1.8 2002/07/26 11:38:23 peteri Exp $ */

#ifndef DEBUG_H
#define DEBUG_H

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdio.h>
#include "mesh.h"
#include "config.h"

/* debuging level: 0 - no debuging information */
/* debuging level: 1 - verbose information */
/* debuging level: 2 - more verbose information */
/* debuging level: 3 - sanity checks on */
/* debuging level: 4 - sanity checks + detailed logging */

extern int vm_verbose_level; 

#define DEBUG_LEVEL 2
/*#define DEBUG_ADDCHECK *//* switch on additional checking */

int CountSplitedEdges (MeshGenData *mgds);

#ifdef __cplusplus
}
#endif

#endif /* DEBUG_H */

/* Modifications:
 * $Log: debug.h,v $
 * Revision 1.8  2002/07/26 11:38:23  peteri
 * - nana is removed for simplicity
 * - edge stores split edges and not splitting points
 *
 * Revision 1.7  2002/02/24 19:01:04  romek
 * *** empty log message ***
 *
 * Revision 1.6  2002/02/16 18:58:47  romek
 * Doc fix.
 *
 */


