/********************************************************************
 nodelem.h -- 

 The function e_InitMeshPointElemConnection is to curtuasy of 
 Peter Ivanyi.

 Roman Putanowicz <romek@sect.mce.hw.ac.uk>
 SECT Research Group, Heriot-Watt University, Edinburgh    
 ********************************************************************/

/* $Id: nodelem.h,v 1.2 2002/01/31 21:27:57 peteri Exp $ */

#ifndef NODELEM_H
#define NODELEM_H

#include "e_lib.h"
    
void e_InitMeshPointElemConnection(MESH *mesh,
                                   int *no_node_elem, 
                                   int **node_elem);
            
#endif /* NODELEM_H */

/* Modifications:
 * $Log: nodelem.h,v $
 * Revision 1.2  2002/01/31 21:27:57  peteri
 * Major reorganization in the code.
 * - It is split into smaller modules.
 * - Some types, functions are renamed
 * - Proper flipping of edges is implemented
 *
 * Revision 1.1.1.1  2002/01/30 10:20:56  peteri
 * Imported using TkCVS
 *
 * Revision 1.1  2001/07/14 17:42:17  romek
 * Initial revision
 *
 */ 
            
