
/* Algorithm control  */
#define CRITERIA            1.5  /* nodes within the circle with a radius of
                                    required length times CRITERIA is immediately
                                    accepted */
#define NO_CHORD_NODES      5    /* no. of nodes generated perpendicular to
                                    the reference segment,  */
#define MAX_NO_NEAR_NODES   20   /* max no of nodes which are near 
                                    to the chord apex */

/* Internal control, change only if you know what you are doing  */
#define INCREMENT           64   /* vector or matrix increment factor */

#define CLOSE_NODE          1e-8 /* two nodes are identical if they are closer, used
                                    in mesh parameter determination, common.c  */

#define TOLERANCE           1e-8 /* smaller values are considered to be zero */

