#ifndef BOUNDARY_H__
#define BOUNDARY_H__

#include "e_lib.h"
#include "inside.h"
#include "mgni.h"

typedef struct
{
  int  n;
  int *found;
  int *mesh;
  int *bnd;
  int *list;
  int *edge;
} 
MATCH_EDGE;

typedef struct
{
  MATCH_EDGE  oe;
  int         nie;
  MATCH_EDGE *ie;
}
MATCH_BND;


void Gen2DBoundary(MESH *mesh, int *NoNodeElem, int **NodeElem,
                   int *NBoundaries, BND **Boundaries);

void Free2DBoundary(int NBList, BND *BList);

void MatchAll2DBoundaries(int noldmesh, MESH **oldmesh, int nnewmesh, MESH **newmesh, 
                          int *noldbnd, BND **oldbnd, int *nnewbnd, BND **newbnd, 
                          MATCH_BND ***oldmatch, double epsilon, int perfect);

void Free2DMatchBnd(int NBList, MATCH_BND *BList);

#endif


