int e_2D_triangulate(double ***coords, int *nn, BND *bnd, int ***triangles,
                     MTRF *mtrf);

/* this function triangulates the domain defined by 
    + the set of _nn_ nodes
    + for which coordinates are given in _coords_
      (only coords[i][0] and coords[i][1] will be accessed)
    + _nn_ and _coords_ are give by means of addresses as extra stitching
      node might be added to the end of the _coords_ matrix
    + it is the task of the user of this function to compare values of
      _nn_ before and after the function_ to see if any stitching was done
    + the boundary information given in the boundary structure _bnd_
      (_bnd->en_ is of length _bnd->nen_ and has node numbers in it)
   the resulting triangulation will be put in
    + the integer array _triangles_ to which a pointer is given
   the return value is the number of triangles made.                  */ 
