#ifndef MGN_SMSH_H
#define MGN_SMSH_H

/************************************************************

	filter translates an e_lib mdf file into smsh format.
	it works for meshes with TRIANG1 triangles and
	regions of surface elements in LINK1-5.

	use smsh_add_surfelem to add LINK1-5 to a TRIANG1/QUAD1 mesh.

 ************************************************************/

#include "e_lib.h"

int smsh_add_surfelem(MESH *m);

int smsh_output(MESH *m, char *fname);

#endif

