/********************************************************************
 * SECT Research Group, Heriot-Watt University, Edinburgh           *
 * Copyright 2001                                                   *
 * For license see LICENSE file                                     *
 ********************************************************************/

/* This is the hack which allows to include various paresers generated
 * by lex and yacc to be included in the same binaries
 * It renames all exported symbols.
 */

/* $Id: ctr_guard.h,v 1.1.1.1 2002/01/30 10:20:55 peteri Exp $ */

/* ctr_guard.h */

#ifndef CTR_GUARD_H
#define CTR_GUARD_H
/* renaming lexer symbols */
#ifndef yywrap
#   define yywrap       CTRwrap
#endif

#ifndef yylex
#  define yylex          CTRlex
#endif

/* renaming parser sym bols */
#define yymaxdepth CTR_maxdepth
#define yyparse    CTR_parse
#define yyerror    CTR_error
#define yylval     CTR_lval
#define yychar     CTR_char
#define yydebug    CTR_debug
#define yypact     CTR_pact
#define yyr1       CTR_r1
#define yyr2       CTR_r2
#define yydef      CTR_def
#define yychk      CTR_chk
#define yypgo      CTR_pgo
#define yyact      CTR_act
#define yyexca     CTR_exca
#define yyerrflag  CTR_errflag
#define yynerrs    CTR_nerrs
#define yyps       CTR_ps
#define yypv       CTR_pv
#define yy_yys     CTR_yys
#define yystat     CTR_state
#define yytmp      CTR_tmp
#define yyv        CTR_v
#define yy_yyv     CTR_yyv
#define yyval      CTR_val
#define yyloc      CTR_loc
#define yyreads    CTR_reads
#define yytoks     CTR_toks
#define yylhs      CTR_yylhs
#define yylen      CTR_yylen
#define yydefred   CTR_yydefred
#define yydgoto    CTR_yydgoto
#define yysindex   CTR_yysindex
#define yyrindex   CTR_yyrindex
#define yygindex   CTR_yygindex
#define yytable    CTR_yytable
#define yycheck    CTR_yycheck
#define yyname     CTR_yyname
#define yyrule     CTR_yyrule

#endif /* CTR_GUARD_H */

